<?php

class actionShowcaseConfirm extends cmsAction {

    public function run($id = false){
		
		if (!$id){ cmsCore::error404(); }
		
		if(!$this->cms_user->is_logged){
			cmsUser::goLogin();
		}

		$order = $this->model->getData('sc_checkouts', $id);
		if (!$order){ cmsCore::error404(); }
		
		$is_manager = ($this->cms_user->id && in_array($this->cms_user->id, $this->managers) || $this->cms_user->is_admin);
		
		if (!$is_manager && $order['user_id'] != $this->cms_user->id){
			cmsUser::addSessionMessage('Ошибка доступа', 'error');
			$this->redirectBack();
		}
		
		if ($order['status'] != 3){
			cmsUser::addSessionMessage('Ошибка статус заказа', 'error');
			$this->redirectBack();
		}

		$result = $this->model->updData('sc_checkouts', $id, array('status' => 4));
		if ($result){
			
			cmsEventsManager::hook('sc_order_status', array($order, 4));

			if (!empty($order['fields']) && $is_manager){
				$status = $this->getStatuses(4);
				$cart_fields = cmsModel::yamlToArray($order['fields']);
				if (!empty($cart_fields['email'])){
					$to = array('email' => $cart_fields['email'], 'name' => $cart_fields['name']);
					$hash = !empty($order['user_id']) ? '' : '?access=' . hash("adler32", $id . $cart_fields['email']);
					$mail_data = array(
						'nickname' => $cart_fields['name'],
						'order_id' => $id,
						'status' => $status,
						'url' => href_to_abs('showcase', 'orders', array($id, 1)) . $hash
					);
					cmsCore::getController('messages')->sendEmail($to, array('name' => 'sc_order_status'), $mail_data);
				}
			}
			

			if (!empty($this->options['log'])){
				$author = '<a href="' . href_to('users', $this->cms_user->id) . '" target="_blank">' . $this->cms_user->nickname . '</a>';
				$title = '<a href="' . href_to('showcase', 'orders', array($id, 4)) . '" data-toggle="tooltip" data-placement="top" title="Заказ №' . $id . '" target="_blank">заказа</a> на ' . $this->getStatuses(4);
				$this->model->saveData('sc_logs', array(
					'style' => 'success',
					'icon' => 'glyphicon glyphicon-cog',
					'text' => $author . ' изменил статус ' . $title
				));
			}
			
			cmsUser::addSessionMessage('Статус успешно изменена', 'success');

		} else {
			cmsUser::addSessionMessage('Статус успешно изменена', 'error');
		}
		
		$this->redirectBack();

    }

}
