<?php

class actionShowcaseDeliverySet extends cmsAction {

    public function run($id = false){
		
		$is_manager = ($this->cms_user->id && in_array($this->cms_user->id, $this->managers) || $this->cms_user->is_admin);
		if (!$id || !$is_manager){ cmsCore::error404(); }
		
		$order = $this->model->getData('sc_checkouts', $id);
		if (!$order){ cmsCore::error404(); }
		
		$form = $this->getForm('delivery', array($order['id']));
		
		if ($this->request->get('submit')){

			$data = $form->parse($this->request, true);
			$errors = $form->validate($this, $data);
			
			if (!$errors){
				$result = $this->model->updData('sc_checkouts', $order['id'], array('delivery_track' => $data));
				if ($result){
					cmsUser::addSessionMessage(LANG_SUCCESS_MSG, 'success');
					$this->redirectTo('showcase', 'orders', array($order['id'], $order['status']));
				} else {
					cmsUser::addSessionMessage('Не удалось обновить данные.', 'error');
				}
			} else {
				cmsUser::addSessionMessage(LANG_FORM_ERRORS,'error');
			}
			
		}
		
        return $this->cms_template->render('delivery_set', array(
			'order' => $order,
			'form' => $form,
			'data' => isset($data) ? $data : false,
			'errors' => isset($errors) ? $errors : false
		));

    }

}
